unit Unit1;

{
  form & buttons to test xfont class
}  

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, dav7Colorpicker, ExtCtrls, davArrayBtn,
  Buttons, XBitmap;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    graphFGselect: Tdav7ColorPicker;
    graphBGselect: Tdav7ColorPicker;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    textBGselect: Tdav7ColorPicker;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    textFGcolor: TStaticText;
    textBGcolor: TStaticText;
    graphFGcolor: TStaticText;
    graphBGcolor: TStaticText;
    textFGUpDown: TUpDown;
    textBGUpDown: TUpDown;
    graphFGUpDown: TUpDown;
    graphBGUpDown: TUpDown;
    styleBtn: TDavArrayBtn;
    Label8: TLabel;
    clearBtn: TSpeedButton;
    graph1Btn: TSpeedButton;
    graph2Btn: TSpeedButton;
    Label9: TLabel;
    Edit1: TEdit;
    Label10: TLabel;
    textFGselect: Tdav7ColorPicker;
    StaticText1: TStaticText;
    textheightUpDown: TUpDown;
    Label12: TLabel;
    clipBtn: TSpeedButton;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    XUpDown: TUpDown;
    YUpDown: TUpDown;
    Label11: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    BG1Btn: TSpeedButton;
    BG2Btn: TSpeedButton;
    StaticText4: TStaticText;
    fontNrUpDown: TUpDown;
    Label16: TLabel;
    fontnametext: TStaticText;
    Label17: TLabel;
    Image1: TImage;
    Image2: TImage;
    image3: TImage;
    fontInstallBtn: TSpeedButton;
    showdataBtn: TSpeedButton;
    writeBtn: TSpeedButton;
    StaticText5: TStaticText;
    charUpDown: TUpDown;
    metricsBtn: TSpeedButton;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    showfontBtn: TSpeedButton;
    clocktext: TLabel;
    modrectBtn: TSpeedButton;
    procedure styleBtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure textFGselectSelect(sender: TObject; color: Integer);
    procedure textBGselectSelect(sender: TObject; color: Integer);
    procedure graphFGselectSelect(sender: TObject; color: Integer);
    procedure graphBGselectSelect(sender: TObject; color: Integer);
    procedure clipBtnClick(Sender: TObject);
    procedure fontInstallBtnClick(Sender: TObject);
    procedure showdataBtnClick(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure fontNrUpDownMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure metricsBtnClick(Sender: TObject);
    procedure writeBtnClick(Sender: TObject);
    procedure showfontBtnClick(Sender: TObject);
    procedure styleBtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure graph1BtnClick(Sender: TObject);
    procedure graphFGUpDownMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure graphBGUpDownMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure textFGUpDownMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure textBGUpDownMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure graph2BtnClick(Sender: TObject);
    procedure modrectBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses XFontUnit,timerunit;

var map1 : TXbitmap;
    textFG : DWORD = $00000000;
    textBG : DWORD = $00ffffff;
    graphFG : DWORD= $00000000;
    graphBG : DWORD= $00ffffff;
    Xfont : TXfont;
    textstyle : byte = 0;
    XFcliprect : Trect;

procedure settextstyle;
var i : byte;
begin
 textstyle := 0;
 for i := 0 to 4 do
  with form1.styleBtn do
   if GetBtnStatus(i) = stDown then textstyle := textstyle or (1 shl i);
end;   

procedure TForm1.styleBtnBtnPaint(sender: TObject; BtnNr: Byte;
                                  status: TBtnStatus);
const styletext : array[0..4] of string =
                  ('bold','italic','w i d e','background','underline');
var r : Trect;
    x,y : word;
begin
 with styleBtn do with canvas do
  begin
   r := getBtnRect(BtnNr);
   brush.style := bsClear;
   font.Style := [];
   font.Height := 16;
   case btnNr of
    0 : font.Style := [fsBold];
    1 : font.style := [fsItalic];
    3 : begin
         brush.style := bsSolid;
         brush.Color := $ffa0ff;
        end;
    4 : font.Style := [fsUnderline];
   end;
  x := r.Left + (btnWidth - textwidth(styletext[btnNr])) div 2;
  y := r.Top + (btnHeight - textheight(styletext[BtnNr])) div 2;
  textout(x,y,styletext[BtnNr]);
 end;
end;

procedure TForm1.FormPaint(Sender: TObject);
//paint edge around paintbox
var x1,y1,x2,y2 : word;
    i : byte;
begin
 with paintbox1 do
  begin
   x1 := left - 2;
   y1 := top - 2;
   x2 := left + width + 1;
   y2 := top + height + 1;
  end;
 with canvas do
  for i := 0 to 1 do
   begin
    pen.width := 1;
    pen.color := 0;
    moveto(x2,y1);
    lineto(x1,y1);
    lineto(x1,y2);
    pen.Color := $c0c0c0;
    lineto(x2,y2);
    lineto(x2,y1);
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i : byte;
begin
 with styleBtn do
  for i := 0 to columns-1 do
   begin
    setBtnOpmode(i,omToggle);
    setBtnGroup(i,i);
   end; 
 map1 := TXbitmap.create;
 with map1 do with canvas do
  begin
   width := form1.width;
   height := form1.Height;
   brush.Color := $ffffff;
   fillrect(rect(0,0,width,height));
   XFcliprect := rect(0,0,width,height); 
  end;

 with FontNrUpDown do max := maxfontcount;
 setCPUclock;
 clocktext.Caption := 'CPUclock = '+formatfloat('#0',CPUclock)+' MHz';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 XFont.Free;
 XFont := nil;
 map1.Free;
 map1 := nil;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintbox1.Canvas.Draw(0,0,map1);
end;

procedure TForm1.textFGselectSelect(sender: TObject; color: Integer);
begin
 textFG := colorlevel(color,textFGUpDown.Position);
end;

procedure TForm1.textBGselectSelect(sender: TObject; color: Integer);
begin
 textBG := colorlevel(color,textBGUpDown.Position);
end;

procedure TForm1.graphFGselectSelect(sender: TObject; color: Integer);
begin
 graphFG := colorlevel(color,graphFGUpDown.Position);
end;

procedure TForm1.graphBGselectSelect(sender: TObject; color: Integer);
begin
 graphBG := colorlevel(color,graphBGUpDown.position);
end;

procedure TForm1.clipBtnClick(Sender: TObject);
//set cliprect
begin
 XFcliprect := rect(50,50,300,100);
 with map1 do
  begin
   Xpenwidth := 1;
   Xusebrush := false;
   Xpencolor := $8080c0;
   with XFcliprect do Xfillrect(left,top,Right-1,Bottom-1,0);
  end;

 paintbox1.Invalidate;
end;

procedure TForm1.fontInstallBtnClick(Sender: TObject);
begin
 Xfont := TXfont.create;
 with Xfont do
  begin
   install(image1);
   install(image2);
   install(image3);
   fontNrUpDown.Position := 1;
   fontNr := 1;
  end;
 fontnametext.Caption := XFont.fontprops.name;
end;

procedure TForm1.showdataBtnClick(Sender: TObject);
//show selected font data
const txt : array[1..9] of string =
            ('name','length','resolution','driver','revision','baseline',
             'HiTop','LoTop','pointer');
var Fontprops : TXFontProps;
    i : byte;
    x,y : word;
begin
 XFont.FontNr := FontNrUpDown.position;
 FontProps := XFont.FontProps;
 with paintbox1.Canvas do
  begin
   font.Name := 'arial';
   font.Height := 20;
   font.color := $808080;
   brush.Style := bsClear;
   x := 400;
   y := 20;
   for i:= 1 to 9 do textout(x,(i-1)*22+y,txt[i]);
   x := 500;
   font.Color := $000000;
   with FontProps do
    begin
     textout(x,y,name);
     inc(y,22);
     textout(x,y,inttostr(length));
     inc(y,22);
     textout(x,y,inttostr(resolution));
     inc(y,22);
     textout(x,y,inttostr(driver));
     inc(y,22);
     textout(x,y,inttostr(revision));
     inc(y,22);
     textout(x,y,inttostr(baseline));
     inc(y,22);
     textout(x,y,inttostr(HiTop));
     inc(y,22);
     textout(x,y,inttostr(LoTop));
     inc(y,22);
     textout(x,y,'$'+inttohex(DWORD(PXFont),8));
    end;
  end;
end;

procedure TForm1.clearBtnClick(Sender: TObject);
//clear the screen
begin
 with map1 do with canvas do
  begin
   brush.Color := $ffffff;
   XFcliprect := rect(0,0,width,height);
   fillrect(Xcliprect);
  end;

 paintbox1.Canvas.Draw(0,0,map1); 
end;

procedure TForm1.fontNrUpDownMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Xfont.FontNr := fontNrUPDown.position;
 fontnametext.Caption := XFont.FontProps.name;
end;

procedure TForm1.metricsBtnClick(Sender: TObject);
//supply metrics of char code
const txt : array[1..5] of string = ('code','width','hspace','top','bottom');
var m : TCharMetrics;
    x,y : word;
    i : byte;
begin
 m := XFont.charmetrics(charUpDown.position);
 with paintbox1.Canvas do
  begin
   font.Name := 'arial';
   font.Height := 20;
   font.color := $808080;
   brush.Style := bsClear;
   x := 400;
   y := 20;
   for i:= 1 to 5 do textout(x,(i-1)*22+y,txt[i]);
   x := 500;
   font.Color := $000000;
   with m do
    begin
     textout(x,y,inttostr(code));
     inc(y,22);
     textout(x,y,inttostr(width));
     inc(y,22);
     textout(x,y,inttostr(hspace));
     inc(y,22);
     textout(x,y,inttostr(top));
     inc(y,22);
     textout(x,y,inttostr(bottom));
    end;
  end;//with canvas
end;

procedure TForm1.writeBtnClick(Sender: TObject);
var i : byte;//style
    t1,t2 : Int64;
begin
 with XFont do
  begin
   textmap := map1;
   fontNr := fontNrUpDown.position;
   fontstyle := textstyle;
   fontheight := textheightUpDown.Position;
   pencolor := textFG;
   brushcolor := textBG;
   posX := XUPDown.position;
   posY := YUpDown.Position;
   cliprect := XFcliprect;
   getCPUticks(t1);
   for i := 1 to length(Edit1.Text) do charOut(byte(Edit1.text[i]));
   getCPUticks(t2);
  end;
 paintbox1.Canvas.Draw(0,0,map1);
 clocktext.Caption := formatfloat('####0',ProcTime(t2-t1))+' usecs';
end;

procedure TForm1.showfontBtnClick(Sender: TObject);
var i,j : byte;
begin
 with XFont do
  begin
   textmap := map1;
   FontNr := fontNrUpDown.position;
   pencolor := textFG;
   brushcolor := textBG;
   fontheight := 20;
   fontStyle := textstyle;
   for j := 0 to 15 do
    begin
     posY := 20 * j;
     for i := 0 to 15 do
      begin
       posX := 25 * i;
       charout(i + (j shl 4));
      end;
    end;//for j
  end;//with XFont
 paintbox1.Canvas.Draw(0,0,map1);
end;

procedure TForm1.styleBtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 settextstyle;
end;

procedure TForm1.graph1BtnClick(Sender: TObject);
//paint graph1 as text background
begin
 with map1 do
  begin
   Xpencolor := graphFG;
   Xbrushcolor := graphBG;
   XUsebrush := true;
   Xpenwidth:= 5;
   Xlinestyle := 0;
   Xarrowcode := 0;
   Xellipse(20,20,600,200);
  end;
 paintbox1.Canvas.Draw(0,0,map1);
end;

procedure TForm1.graph2BtnClick(Sender: TObject);
//paint graph2 as text background
var i : byte;
begin
 with map1 do
  begin
   Xpencolor := graphBG;
   Xbrushcolor := graphBG;
   XUsebrush := true;
   Xpenwidth:= 2;
   Xlinestyle := 0;
   Xarrowcode := 0;
   Xfillrect(0,0,width,height,0);
   XpenColor := graphFG;
   for i := 1 to 37 do xline(i*20,0,i*20,height);
   for i := 1 to 15 do xline(0,i*20,width,i*20);
  end;
 paintbox1.Canvas.Draw(0,0,map1);
end;

procedure TForm1.graphFGUpDownMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 graphFG := colorlevel(graphFG,graphFGUpDown.Position);
end;

procedure TForm1.graphBGUpDownMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 graphBG := colorlevel(graphBG,graphBGUpDown.Position);
end;

procedure TForm1.textFGUpDownMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 textFG := colorlevel(color,textFGUpDown.Position);
end;

procedure TForm1.textBGUpDownMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 textBG := colorlevel(color,textBGUpDown.Position);
end;

procedure TForm1.modrectBtnClick(Sender: TObject);
//show modrect
var r : Trect;
begin
 r := XFont.modrect;
 with map1 do
  begin
   Xlinestyle := 1;
   Xpenwidth := 1;
   Xpencolor := $808080;
   Xusebrush := false;
   Xfillrect(r.Left-1,r.Top-1,r.Right,r.bottom,0)
  end;
 paintbox1.Canvas.Draw(0,0,map1);
end;

end.
